/*
 * Copyright (c) 1991 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * @(#) $Header: class.h,v 1.12 93/07/06 17:47:24 floyd Exp $ (LBL)
 */

struct idlist {
	struct idlist *next;
	char *id;
};

extern struct idlist *makeid(char *, struct idlist *);

/* XXX */
#define C_CLASS 63

struct statlist {
        int pkts;       /* no. of packets transmitted by class */
        int bytes;      /* no. of bytes transmitted by class */
	double mean;	/* mean class bandwidth in bytes/sec */
	double var;	/* variance of class bandwidth */
	double cap;	/* equivalent capacity */
	int conns;	/* number of admitted connections */
};

struct class {
	struct rmstate *stp;
	struct ifnet *ifp;
	struct qdisc qd;
	double last;
	double undertime;
	double avgidle;
        struct statlist stats;  /* for the admission control procedure */

	struct class *peer;
	struct class *parent;
	struct class *borrow;
	struct class *equiv;	/* next class with admissions controls */
	int pri;		/* priority */
	int depth;		/* "depth" of class in class tree */
	void (*overlimit)(struct class *);
	double maxidle;
	double minidle;
	double extradelay;
	double maxrate;		/* bytes per second allowed this class */
	int admit;      	/* 1 for admissions controls, 0 for not */
	double epsilon;		/* for equivalent capacity */
	double weight;		/* for computing average class throughput */
	int bytes_alloc;	/* num. of bytes allocated for current round */
	int delayed;		/* 1 for an already-delayed class */
        char *plot_fname;
	FILE *plotfile;

	/*
	 * Temporary things while constructing data structures.
	 */
	char *name;
	char *pname;
	char *bname;
	char *qname;
	char *oname;
	double allotment;
	struct class *next;
	struct idlist *members;
	int lineno;
	int mark;
	struct namebind *nb;
	struct attr *attr;
};

struct class *classbuild(char *, struct attr *, struct idlist *, int);
void classdef(struct class *);
struct class *getclasslist(int, struct ifnet **);
struct class *classlookup(struct class *, char *);
