/*
 * Copyright (c) 1990 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Lawrence Berkeley Laboratory,
 * Berkeley, CA.  The name of the University may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef lint
static char rcsid[] =
"@(#) $Header: telnet.c,v 1.6 91/08/26 23:13:28 mccanne Exp $ (LBL)";
#endif

#include <stdio.h>
#include <sys/types.h>
#include <math.h>

#include "config.h"
#include "real.h"
#include "packet.h"
#include "tcp.h"
#include "at.h"

struct crstate {
	int size;
	double interval;
	int started;
};

static struct at_options options[] = {
	{ "interval", AT_DOUBLE, offsetof(struct crstate, interval) },
	{ "size", AT_INT, offsetof(struct crstate, size) },
	{ 0 },
};

void
cr_init(ap)
	register struct application *ap;
{
	register struct crstate *stp;

	stp = (struct crstate *)malloc(sizeof *stp);
	bzero((char *)stp, sizeof(*stp));
	atl_init(ap->ap_nb, ap->ap_attr, options, (char *)stp);
	stp->interval *= 1e6;
	ap->ap_size = stp->size;
	ap->ap_type = CRATE;
	ap->ap_state = (void *)stp;
}

int
cr_send(ap)
	register struct application *ap;
{
	struct crstate *stp = (struct crstate *)ap->ap_state;

	if (!stp->started) {
		stp->started = 1;
		apptimer(ap->ap_proto->pr_cid, stp->interval);
	}
	return 0;
}

void
cr_timeout(ap, id)
	struct application *ap;
	int id;
{
	struct crstate *stp = (struct crstate *)ap->ap_state;

	(*ap->ap_proto->pr_async)(ap->ap_proto, 1);
	apptimer(ap->ap_proto->pr_cid, stp->interval);
}
